import { TextDocumentSyncKind } from 'vscode-languageserver-protocol';
import { QUERY_COMPARISON_OPERATORS, QUERY_LOGICAL_OPERATORS, SEPARATOR_SIGN, DELIMITER_SIGN, SELECTOR_SIGNS, AT_SIGN } from '@master/css';

const INVOKED_TRIGGER_CHARACTERS = [
    '"',
    ' ',
    '\''
];
const VALUE_TRIGGER_CHARACTERS = [
    SEPARATOR_SIGN,
    DELIMITER_SIGN
];
const SELECTOR_TRIGGER_CHARACTERS = SELECTOR_SIGNS;
const AT_TRIGGER_CHARACTER = AT_SIGN;
const QUERY_TRIGGER_CHARACTERS = [
    ...QUERY_COMPARISON_OPERATORS,
    ...QUERY_LOGICAL_OPERATORS
];
const GROUP_TRIGGER_CHARACTER = '{';
const DECLARATION_SEPARATOR_TRIGGER_CHARACTER = ';';
const SERVER_CAPABILITIES = {
    textDocumentSync: TextDocumentSyncKind.Incremental,
    // Tell the client that this server supports code completion.
    completionProvider: {
        resolveProvider: false,
        workDoneProgress: false,
        triggerCharacters: [
            ...new Set([
                ...INVOKED_TRIGGER_CHARACTERS,
                ...VALUE_TRIGGER_CHARACTERS,
                ...SELECTOR_TRIGGER_CHARACTERS,
                ...QUERY_TRIGGER_CHARACTERS,
                DECLARATION_SEPARATOR_TRIGGER_CHARACTER,
                AT_TRIGGER_CHARACTER,
                GROUP_TRIGGER_CHARACTER
            ])
        ]
    },
    colorProvider: true,
    hoverProvider: true,
    workspace: {
        workspaceFolders: {
            supported: true
        }
    }
};

export { AT_TRIGGER_CHARACTER, DECLARATION_SEPARATOR_TRIGGER_CHARACTER, GROUP_TRIGGER_CHARACTER, INVOKED_TRIGGER_CHARACTERS, QUERY_TRIGGER_CHARACTERS, SELECTOR_TRIGGER_CHARACTERS, SERVER_CAPABILITIES, VALUE_TRIGGER_CHARACTERS };
